	component D5M_VIP_QSYS is
		port (
			clk_50                                    : in    std_logic                     := 'X';             -- clk
			reset_n                                   : in    std_logic                     := 'X';             -- reset_n
			zs_addr_from_the_sdram                    : out   std_logic_vector(12 downto 0);                    -- addr
			zs_ba_from_the_sdram                      : out   std_logic_vector(1 downto 0);                     -- ba
			zs_cas_n_from_the_sdram                   : out   std_logic;                                        -- cas_n
			zs_cke_from_the_sdram                     : out   std_logic;                                        -- cke
			zs_cs_n_from_the_sdram                    : out   std_logic;                                        -- cs_n
			zs_dq_to_and_from_the_sdram               : inout std_logic_vector(15 downto 0) := (others => 'X'); -- dq
			zs_dqm_from_the_sdram                     : out   std_logic_vector(1 downto 0);                     -- dqm
			zs_ras_n_from_the_sdram                   : out   std_logic;                                        -- ras_n
			zs_we_n_from_the_sdram                    : out   std_logic;                                        -- we_n
			clk_sdram_clk                             : out   std_logic;                                        -- clk
			clk_vga_clk                               : out   std_logic;                                        -- clk
			ledr_external_connection_export           : out   std_logic_vector(9 downto 0);                     -- export
			key_external_connection_export            : in    std_logic_vector(3 downto 0)  := (others => 'X'); -- export
			sw_external_connection_export             : in    std_logic_vector(9 downto 0)  := (others => 'X'); -- export
			alt_vip_itc_0_clocked_video_vid_clk       : in    std_logic                     := 'X';             -- vid_clk
			alt_vip_itc_0_clocked_video_vid_data      : out   std_logic_vector(23 downto 0);                    -- vid_data
			alt_vip_itc_0_clocked_video_underflow     : out   std_logic;                                        -- underflow
			alt_vip_itc_0_clocked_video_vid_datavalid : out   std_logic;                                        -- vid_datavalid
			alt_vip_itc_0_clocked_video_vid_v_sync    : out   std_logic;                                        -- vid_v_sync
			alt_vip_itc_0_clocked_video_vid_h_sync    : out   std_logic;                                        -- vid_h_sync
			alt_vip_itc_0_clocked_video_vid_f         : out   std_logic;                                        -- vid_f
			alt_vip_itc_0_clocked_video_vid_h         : out   std_logic;                                        -- vid_h
			alt_vip_itc_0_clocked_video_vid_v         : out   std_logic;                                        -- vid_v
			d5m_conduit_end_D                         : in    std_logic_vector(11 downto 0) := (others => 'X'); -- D
			d5m_conduit_end_FVAL                      : in    std_logic                     := 'X';             -- FVAL
			d5m_conduit_end_LVAL                      : in    std_logic                     := 'X';             -- LVAL
			d5m_conduit_end_PIXCLK                    : in    std_logic                     := 'X';             -- PIXCLK
			d5m_xclkin_clk                            : out   std_logic;                                        -- clk
			d5m_i2c_sclk_external_connection_export   : out   std_logic;                                        -- export
			d5m_i2c_sdat_external_connection_export   : inout std_logic                     := 'X';             -- export
			d5m_trigger_external_connection_export    : out   std_logic;                                        -- export
			d5m_reset_n_external_connection_export    : out   std_logic                                         -- export
		);
	end component D5M_VIP_QSYS;

	u0 : component D5M_VIP_QSYS
		port map (
			clk_50                                    => CONNECTED_TO_clk_50,                                    --                    clk_50_clk_in.clk
			reset_n                                   => CONNECTED_TO_reset_n,                                   --              clk_50_clk_in_reset.reset_n
			zs_addr_from_the_sdram                    => CONNECTED_TO_zs_addr_from_the_sdram,                    --                       sdram_wire.addr
			zs_ba_from_the_sdram                      => CONNECTED_TO_zs_ba_from_the_sdram,                      --                                 .ba
			zs_cas_n_from_the_sdram                   => CONNECTED_TO_zs_cas_n_from_the_sdram,                   --                                 .cas_n
			zs_cke_from_the_sdram                     => CONNECTED_TO_zs_cke_from_the_sdram,                     --                                 .cke
			zs_cs_n_from_the_sdram                    => CONNECTED_TO_zs_cs_n_from_the_sdram,                    --                                 .cs_n
			zs_dq_to_and_from_the_sdram               => CONNECTED_TO_zs_dq_to_and_from_the_sdram,               --                                 .dq
			zs_dqm_from_the_sdram                     => CONNECTED_TO_zs_dqm_from_the_sdram,                     --                                 .dqm
			zs_ras_n_from_the_sdram                   => CONNECTED_TO_zs_ras_n_from_the_sdram,                   --                                 .ras_n
			zs_we_n_from_the_sdram                    => CONNECTED_TO_zs_we_n_from_the_sdram,                    --                                 .we_n
			clk_sdram_clk                             => CONNECTED_TO_clk_sdram_clk,                             --                        clk_sdram.clk
			clk_vga_clk                               => CONNECTED_TO_clk_vga_clk,                               --                          clk_vga.clk
			ledr_external_connection_export           => CONNECTED_TO_ledr_external_connection_export,           --         ledr_external_connection.export
			key_external_connection_export            => CONNECTED_TO_key_external_connection_export,            --          key_external_connection.export
			sw_external_connection_export             => CONNECTED_TO_sw_external_connection_export,             --           sw_external_connection.export
			alt_vip_itc_0_clocked_video_vid_clk       => CONNECTED_TO_alt_vip_itc_0_clocked_video_vid_clk,       --      alt_vip_itc_0_clocked_video.vid_clk
			alt_vip_itc_0_clocked_video_vid_data      => CONNECTED_TO_alt_vip_itc_0_clocked_video_vid_data,      --                                 .vid_data
			alt_vip_itc_0_clocked_video_underflow     => CONNECTED_TO_alt_vip_itc_0_clocked_video_underflow,     --                                 .underflow
			alt_vip_itc_0_clocked_video_vid_datavalid => CONNECTED_TO_alt_vip_itc_0_clocked_video_vid_datavalid, --                                 .vid_datavalid
			alt_vip_itc_0_clocked_video_vid_v_sync    => CONNECTED_TO_alt_vip_itc_0_clocked_video_vid_v_sync,    --                                 .vid_v_sync
			alt_vip_itc_0_clocked_video_vid_h_sync    => CONNECTED_TO_alt_vip_itc_0_clocked_video_vid_h_sync,    --                                 .vid_h_sync
			alt_vip_itc_0_clocked_video_vid_f         => CONNECTED_TO_alt_vip_itc_0_clocked_video_vid_f,         --                                 .vid_f
			alt_vip_itc_0_clocked_video_vid_h         => CONNECTED_TO_alt_vip_itc_0_clocked_video_vid_h,         --                                 .vid_h
			alt_vip_itc_0_clocked_video_vid_v         => CONNECTED_TO_alt_vip_itc_0_clocked_video_vid_v,         --                                 .vid_v
			d5m_conduit_end_D                         => CONNECTED_TO_d5m_conduit_end_D,                         --                  d5m_conduit_end.D
			d5m_conduit_end_FVAL                      => CONNECTED_TO_d5m_conduit_end_FVAL,                      --                                 .FVAL
			d5m_conduit_end_LVAL                      => CONNECTED_TO_d5m_conduit_end_LVAL,                      --                                 .LVAL
			d5m_conduit_end_PIXCLK                    => CONNECTED_TO_d5m_conduit_end_PIXCLK,                    --                                 .PIXCLK
			d5m_xclkin_clk                            => CONNECTED_TO_d5m_xclkin_clk,                            --                       d5m_xclkin.clk
			d5m_i2c_sclk_external_connection_export   => CONNECTED_TO_d5m_i2c_sclk_external_connection_export,   -- d5m_i2c_sclk_external_connection.export
			d5m_i2c_sdat_external_connection_export   => CONNECTED_TO_d5m_i2c_sdat_external_connection_export,   -- d5m_i2c_sdat_external_connection.export
			d5m_trigger_external_connection_export    => CONNECTED_TO_d5m_trigger_external_connection_export,    --  d5m_trigger_external_connection.export
			d5m_reset_n_external_connection_export    => CONNECTED_TO_d5m_reset_n_external_connection_export     --  d5m_reset_n_external_connection.export
		);

