
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE0_CV_D5M_VIP(

	//////////// CLOCK //////////
	input 		          		CLOCK_50,
	input 		          		CLOCK2_50,
	input 		          		CLOCK3_50,
	inout 		          		CLOCK4_50,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [15:0]		DRAM_DQ,
	output		          		DRAM_LDQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_UDQM,
	output		          		DRAM_WE_N,

	//////////// SEG7 //////////
	output		     [6:0]		HEX0,
	output		     [6:0]		HEX1,
	output		     [6:0]		HEX2,
	output		     [6:0]		HEX3,
	output		     [6:0]		HEX4,
	output		     [6:0]		HEX5,

	//////////// KEY //////////
	input 		     [3:0]		KEY,
	input 		          		RESET_N,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// PS2 //////////
	inout 		          		PS2_CLK,
	inout 		          		PS2_CLK2,
	inout 		          		PS2_DAT,
	inout 		          		PS2_DAT2,

	//////////// microSD Card //////////
	output		          		SD_CLK,
	inout 		          		SD_CMD,
	inout 		     [3:0]		SD_DATA,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// VGA //////////
	output		     [3:0]		VGA_B,
	output		     [3:0]		VGA_G,
	output		          		VGA_HS,
	output		     [3:0]		VGA_R,
	output		          		VGA_VS,

	//////////// GPIO_1, GPIO_1 connect to D5M - 5M Pixel Camera //////////
	input 		    [11:0]		D5M_D,
	input 		          		D5M_FVAL,
	input 		          		D5M_LVAL,
	input 		          		D5M_PIXCLK,
	output		          		D5M_RESET_N,
	output		          		D5M_SCLK,
	inout 		          		D5M_SDATA,
	input 		          		D5M_STROBE,
	output		          		D5M_TRIGGER,
	output		          		D5M_XCLKIN
);



//=======================================================
//  REG/WIRE declarations
//=======================================================

wire system_reset_n;

wire DLY_RST_1;
wire DLY_RST_3;

//=======================================================
//  Structural coding
//=======================================================

assign system_reset_n = RESET_N;

//reset signals
Reset_Delay			Reset_Delay_inst(
							.iCLK(CLOCK_50),
							.iRST(KEY[0]),
							.oRST_0(),
							.oRST_1(DLY_RST_1),
							.oRST_2(),
							.oRST_3(DLY_RST_3), //auto-start start point
							.oRST_4()  //auto-start end point
						);

    D5M_VIP_QSYS u0 (
        .clk_50                                    (CLOCK_50),                                    //                   clk_50_clk_in.clk
        .reset_n                                   (system_reset_n),                                   //             clk_50_clk_in_reset.reset_n
		  
			// sdram
        .zs_addr_from_the_sdram                    (DRAM_ADDR),                    //                      sdram_wire.addr
        .zs_ba_from_the_sdram                      (DRAM_BA),                      //                                .ba
        .zs_cas_n_from_the_sdram                   (DRAM_CAS_N),                   //                                .cas_n
        .zs_cke_from_the_sdram                     (DRAM_CKE),                     //                                .cke
        .zs_cs_n_from_the_sdram                    (DRAM_CS_N),                    //                                .cs_n
        .zs_dq_to_and_from_the_sdram               (DRAM_DQ),               //                                .dq
        .zs_dqm_from_the_sdram                     ({DRAM_UDQM, DRAM_LDQM}),                     //                                .dqm
        .zs_ras_n_from_the_sdram                   (DRAM_RAS_N),                   //                                .ras_n
        .zs_we_n_from_the_sdram                    (DRAM_WE_N),                    //                                .we_n
		  
        .clk_sdram_clk                             (DRAM_CLK),                             //                       clk_sdram.clk
        .clk_vga_clk                               (disp_clk),                               //                         clk_vga.clk
        .ledr_external_connection_export           (LEDR),           //        ledr_external_connection.export
        .key_external_connection_export            (KEY),            //         key_external_connection.export
        .sw_external_connection_export             (SW),             //          sw_external_connection.export
		  
			// VGA
        .alt_vip_itc_0_clocked_video_vid_clk       (disp_clk),       //     alt_vip_itc_0_clocked_video.vid_clk
        .alt_vip_itc_0_clocked_video_vid_data      (disp_data),      //                                .vid_data
        .alt_vip_itc_0_clocked_video_underflow     (),     //                                .underflow
        .alt_vip_itc_0_clocked_video_vid_datavalid (), //                                .vid_datavalid
        .alt_vip_itc_0_clocked_video_vid_v_sync    (disp_vs),    //                                .vid_v_sync
        .alt_vip_itc_0_clocked_video_vid_h_sync    (disp_hs),    //                                .vid_h_sync
        .alt_vip_itc_0_clocked_video_vid_f         (),         //                                .vid_f
        .alt_vip_itc_0_clocked_video_vid_h         (),         //                                .vid_h
        .alt_vip_itc_0_clocked_video_vid_v         (),         //                                .vid_v
		  
		  // D5M
        .d5m_conduit_end_D                         (D5M_D),                         //                 d5m_conduit_end.D
        .d5m_conduit_end_FVAL                      (D5M_FVAL),                      //                                .FVAL
        .d5m_conduit_end_LVAL                      (D5M_LVAL),                      //                                .LVAL
        .d5m_conduit_end_PIXCLK                    (D5M_PIXCLK),                     //                                .PIXCLK
        .d5m_xclkin_clk                            (D5M_XCLKIN),                            //                       d5m_xclkin.clk
//        .d5m_i2c_sclk_external_connection_export   (D5M_SCLK),   // d5m_i2c_sclk_external_connection.export
//        .d5m_i2c_sdat_external_connection_export   (D5M_SDATA),   // d5m_i2c_sdat_external_connection.export
//        .d5m_trigger_external_connection_export    (D5M_TRIGGER),    //  d5m_trigger_external_connection.export
//        .d5m_reset_n_external_connection_export    (D5M_RESET_N)     //  d5m_reset_n_external_connection.export
		  
    );
	 

//	input 		          		D5M_STROBE,
	
/////////////////////////////
// VGA TX
wire [23:0]	disp_data;
wire			disp_clk;
wire			disp_hs;
wire			disp_vs;

assign VGA_CLK						= ~disp_clk;
wire   [7:0] R,G,B;
assign {R ,G, B } = disp_data ;
assign {VGA_R[3:0], VGA_G[3:0], VGA_B[3:0]}	= { R[7:4] , G[7:4] ,B[7:4] } ;
assign VGA_HS						= disp_hs;
assign VGA_VS						= disp_vs;	
assign VGA_BLANK_N 				= 1'b1;
assign VGA_SYNC_N 				= 1'b0;

///////////////////////////////////////////////
//D5M I2C control
I2C_CCD_Config 		i2c_config_inst	(	//	Host Side
							.iCLK(CLOCK_50),
							.iRST_N(DLY_RST_3),
							.iZOOM_MODE_SW(SW[1]),
							.iEXPOSURE_ADJ(KEY[1]),
							.iEXPOSURE_DEC_p(SW[0]),							
							//	I2C Side
							.I2C_SCLK(D5M_SCLK),
							.I2C_SDAT(D5M_SDATA)
						);
// D5M Control
assign	D5M_TRIGGER	=	1'b1;  // TRIGGER
assign	D5M_RESET_N	=	DLY_RST_1;	

endmodule
